Subject: [regext] Fwd: Comments to the feedback about epp-over-http

From: Matthias Pfeifer <[email-masked]>
Date: Tue, 29 Mar 2022 18:54:52 +0200

Hello Mario,

> That said, AFAIK most of cloud providers don't allow to open low level 
sockets. You cannot use any >port except 80 and 443 (HTTP and HTTPS).  I 
imagine that they do that due to security reasons.

I am assuming that you are talking about services the cloud provider 
offers (btw, aws do tcp LB)?

If so, this should clearly stated out otherwise this could be confusing 
the technical community (which is in fact able to set up LBs nearly 
everywhere ;) )

> In addition, from what I've read, TCP load balancers are intended for 
TCP traffic on well-known ports, >such as port 25 for SMTP.

Maybe some of the crappy outofthebox do that. In general TCP doesnt 
care. well-known port numbers are just convention.

On 29.03.22 11:26, Mario Loffredo wrote:
> Hi Matthias,
>
> thanks a lot for your interest and feedback.
>
> Please find my comments inline prefixed with [ML]
>
> Il 28/03/2022 23:40, Matthias Pfeifer ha scritto:
>> Hello,
>>
>> i would also add a comment and questions:
>>
>> >In the perspective of moving to the cloud to achieve scalability and
>> >  cost reduction, it should be further noted that application protocols
>> >   that aren't based on HTTP can be hardly migrated by using cloud-
>> >   native features, both on client side and server side. In addition,
>> >   from the security point of view, registries would be limited in terms
>> >   of the third-party security services available to protect their EPP
>> >   servers.
>>
>> Can you please elaborate on
>>
>> >"registries would be limited in terms of the third-party security 
>> services available to protect their EPP >servers."
>>
>> Why?
>>
>>
>> And also on
>>
>> >"and should be further noted that application protocols
>> >that aren't based on HTTP can be hardly migrated by using cloud-
>> >native features, both on client side and server side. " (since the 
>> cloudproviders offer tcp LB as well)
>>
> [ML] I added the text above following up the feedback provided by 
> Gavin from CentralNIC who probably has already experienced some 
> drawbacks in migrating to cloud his EPP server based on TCP.
>
> @Gavin, you are surely more knowledgeable than me about this topic so 
> if you wish to integrate my response, please feel free to do it.
>
> My knowledge is limited to what I have learnt from the web.
>
> That said, AFAIK most of cloud providers don't allow to open low level 
> sockets. You cannot use any port except 80 and 443 (HTTP and HTTPS).  
> I imagine that they do that due to security reasons.
>
> Honestly don't know whether and how such a block can be bypassed.
>
> In addition, from what I've read, TCP load balancers are intended for 
> TCP traffic on well-known ports, such as port 25 for SMTP.
>
> It seems quite clear to me that cloud platforms have been designed to 
> natively support HTTP-based rather than TCP-based applications.
>
>>
>> >While TCP is connection-oriented, HTTP is stateless but not session
>> >less.  This means that, by making an EPP session untied from the
>> >network connection, the EPP communication over HTTP is more flexible
>> >and efficient than over TCP.
>>
>> They work on different Layers so IMHO its hard to make a comparsion 
>> in that way.
>
> [ML] We can compare their effects on the functioning of an EPP server.
>
> SInce in EPP-over-TCP, an EPP session is mapped on a TCP connection, 
> the session gets lost if the TCP connection breaks down.
>
> This doesn't happen in EPP-over-HTTP because the EPP session is mapped 
> on an HTTP session that is a pure logical concept.
>
> In addition, if the EPP session is maintained outside the EPP server 
> (or a pool of backend servers in a load balancing scheme) , the EPP 
> session doesn't get lost even when the server (or one of the servers 
> that has previously started the EPP session) is stopped.
>
>>
>>
>> >While HTTP load balancers are very common and are quite often 
>> software, TCP load
>> > balancers are usually implemented in dedicated hardware
>>
>> Whats the point? TCP and HTTP LBs are even used in combination
>
> [ML] The point is that HTTP load balancers are more flexible than TCP 
> load balancers because they work at a higher layer.

This is a depends-on field: This might be correct if you LB acts as a 
(reverse)proxy and can simply "more" that just routing packets (it is 
than an application in itself)

>
> Let's suppose, for example, to have an HTTP server based on HTTP/2 and 
> we want to move to QUIC.
>
> I presume that such a change would require little to no effort on the 
> HTTP load balancer.
>
Its also depends on. If someone has provide patches/upgrades for your 
device, probably yes.

I was wondering which problem do you exactly try to solve?

Bandwith issues on EPP services? :)

And the language should focus more on technical aspects and where the 
proposed tech solve concrete issues.

Best, Matthias

>>
>> >An EPP server made up of a server pool must always operate with
>> >respect to the constraint that, once an EPP session is established,
>> >all the requests related to that session should be processed by the
>> >servers in the pool as long as the session is alive.
>>
>> This is true in general and there are workarounds (eg CARP or VRRP  
>> and token)
>> The LB part looks too one-sided to me
>
> [ML] Sorry, can you further clarify your remark?
>
> I confess that I don't know CARP and VRRP in detail but it seems to me 
> that they can't be helpful to figure out how to store session 
> information to make session survive server failures.

Its related to tcp sessions (with openbsd/carp/pfsync) you can easily 
build stateful cluster.

> In the case where sticky sessions are used and each backend server 
> maintains the HTTP sessions it starts, if a server breaks down, you 
> can recover the server but not its sessions.
>
with carp you can cus the session is handled there :)

> Whereas sessions are stored on a persistent memory outside the backend 
> servers and any server is able to serve the EPP requests, you can 
> redirect the EPP traffic to another server without any impact on 
> client side.
>
>
> Anyway, we'll further review that section to make it appear more 
> objective.
>
>>
>> And a comment:
>>
>> >The reasons why we have used session cookiea are that they represent 
>> a standard method >(RFC6265), >well known to the community of REST 
>> service implementers, largely used and natively >supported by 
>> >libraries and frameworks on both client and server side. For 
>> example, it is the same >method used by >rdap-openid to map an RDAP 
>> session and tie it to an access token :-)
>>
>> > Which method other than session cookie shoud be used instead ?
>>
>> For (REST) API I would prefer token(JWT) based model in general. 
>> Login / Logout including session management would add (at least a 
>> little bit) more complexity and probably CORS issues on client side.
>
> [ML] I would agree with you if the goal was to partially or completely 
> refactor EPP but this is not the philosophy behind this proposal.
>
> This proposal aims to preserve EPP commands semantics and makes use of 
> HTTP as a mere transport protocol.
>
> So what are the other practical methods using HTTP that way and 
> preserving the EPP commands?

You could the tcp-session requirement out and add a token based session 
system.

>
>
> James proposed his own one but the authors'opinion is that it involves 
> a very low-level approach.
>
> Except for setting the session cookie, this proposal doesn't require 
> to know any additional features used in the REST context.
>
> Therefore, I think it would be quite easy to wrap the core of an EPP 
> server to make it interact with both a TCP and an HTTP server.
>
> With regard to the use of a JWT token, while reviewing the rdap-openid 
> document the WG has already agreed that it is unfit to be used outside 
> the borders of a trusted environment. As a consequence, Scott
>
> has recently replaced tokens with sessions (the same mechanism used by 
> epp-over-http) in the interaction between a generic RDAP client and an 
> RDAP server and stated tokens to be exchanged between the RDAP server, 
> acting as registered OpenID Connect client, and an OpenID Provider.
>
> It should further be noted that not only the Login command lets the 
> client authenticate but also negotiate the XML namespaces that will be 
> valid during the EPP session. Therefore, the simple replacement of the 
> EPP authentication with another HTTP-based mechanism wouldn't be 
> sufficient.

Well, we do not need OIDC for using JWT (also OIDC wouldnt solve here 
anything).

>>
>>
>> Why we don't chase the transport protocol restriction out of EPP in 
>> general? :)
>
> [ML] Are you proposing to rewrite EPP :-) ?
>
> I don't object to the idea but, IMHO, a general refactoring of EPP 
> should also address other topics; for example, the use of JSON instead 
> of XML so that extensions can be managed more easily.
>
>
> Hope I addresed all your remarks.
>
>
> Best,
>
> Mario
>
>>
>>
>> Thx and best, Matthias
>>
>>
>>
>>
>> On 28.03.22 12:56, Mario Loffredo wrote:
>>> The reasons why we have used session cookiea are that they represent 
>>> a standard method (RFC6265), well known to the community of REST 
>>> service implementers, largely used and natively supported by 
>>> libraries and frameworks on both client and server side. For 
>>> example, it is the same method used by rdap-openid to map an RDAP 
>>> session and tie it to an access token :-)
>>
>> _______________________________________________
>> regext mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/regext
>

---

From: Mario Loffredo <[email-masked]>
Date: Tue, 29 Mar 2022 19:26:49 +0200

Hi Matthias,

Il 29/03/2022 18:54, Matthias Pfeifer ha scritto:
> Hello Marion,
>
> >That said, AFAIK most of cloud providers don't allow to open low 
> level sockets. You cannot use any >port except 80 and 443 (HTTP and 
> HTTPS).  I imagine that they do that due to security reasons.
>
> If so, this should clearly stated out otherwise this could be 
> confusing the technical community (which is in fact able to set up LBs 
> nearly everywhere ;) )
>

Thanks a lot for the heads up.

Surely, we'll review the document to address your feedback.

Best,

Mario

>> That said, AFAIK most of cloud providers don't allow to open low 
>> level sockets. You cannot use any port except 80 and 443 (HTTP and 
>> HTTPS).  I imagine that they do that due to security reasons.
>>
>> This doesn't happen in EPP-over-HTTP because the EPP session is 
>> mapped on an HTTP session that is a pure logical concept.
>>
>> Let's suppose, for example, to have an HTTP server based on HTTP/2 
>> and we want to move to QUIC.
>>
>> I confess that I don't know CARP and VRRP in detail but it seems to 
>> me that they can't be helpful to figure out how to store session 
>> Whereas sessions are stored on a persistent memory outside the 
>> backend servers and any server is able to serve the EPP requests, you 
>> can redirect the EPP traffic to another server without any impact on 
>> client side.
>>
>>
>>> >The reasons why we have used session cookiea are that they 
>>> represent a standard method >(RFC6265), >well known to the community 
>>> of REST service implementers, largely used and natively >supported 
>>> by >libraries and frameworks on both client and server side. For 
>> [ML] I would agree with you if the goal was to partially or 
>> completely refactor EPP but this is not the philosophy behind this 
>> proposal.
>>
>> This proposal aims to preserve EPP commands semantics and makes use 
>> of HTTP as a mere transport protocol.
>>
> You could the tcp-session requirement out and add a token based 
> session system.
>
>
>>
>>
>> James proposed his own one but the authors'opinion is that it 
>> involves a very low-level approach.
>>
>> With regard to the use of a JWT token, while reviewing the 
>> rdap-openid document the WG has already agreed that it is unfit to be 
>> used outside the borders of a trusted environment. As a consequence, 
>> Scott
>>
>> has recently replaced tokens with sessions (the same mechanism used 
>> by epp-over-http) in the interaction between a generic RDAP client 
>> and an RDAP server and stated tokens to be exchanged between the RDAP 
>> server, acting as registered OpenID Connect client, and an OpenID 
>> Provider.
>>
>> client authenticate but also negotiate the XML namespaces that will 
>> be valid during the EPP session. Therefore, the simple replacement of 
>> the EPP authentication with another HTTP-based mechanism wouldn't be 
>> sufficient.
>
>> should also address other topics; for example, the use of JSON 
>> instead of XML so that extensions can be managed more easily.
>>
>>
>>>> The reasons why we have used session cookiea are that they 
>>>> represent a standard method (RFC6265), well known to the community 
>>>> of REST service implementers, largely used and natively supported 
>>>> by libraries and frameworks on both client and server side. For 
-- 
Dr. Mario Loffredo
Technological Unit “Digital Innovation”
Institute of Informatics and Telematics (IIT)
National Research Council (CNR)
via G. Moruzzi 1, I-56124 PISA, Italy
Phone: +39.0503153497
Web: http://www.iit.cnr.it/mario.loffredo

---

From: "Gould, James" <[email-masked]>
Date: Wed, 30 Mar 2022 20:11:52 +0000

Mario,

I provide feedback embedded below.

--

JG

James Gould
Fellow Engineer
[email-masked]<applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com<http://verisigninc.com/>

From: Mario Loffredo <[email-masked]>
Date: Wednesday, March 30, 2022 at 1:10 PM
To: James Gould <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: [EXTERNAL] Re: [regext] Comments to the feedback about epp-over-http

Hi James,

here are again my responses below.
Il 30/03/2022 15:59, Gould, James ha scritto:
Mario,

I include my feedback embedded below.

--

JG

James Gould
Fellow Engineer
[email-masked]<applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com<http://secure-web.cisco.com/1gQlgRW72aj9NC17lGneJe5U9iv40YorDLQeevsbRB0uN549sJtcx2h6AcX90vvTSIQKRY4ndEf784mKH0KqneZZACedjxciuZ_2i5ToIlwfFAGz707PB6ezlmAVSdaxYJbXUL7YKe733dDfgfhwhGI412ZDZ1_V2ISZFA4x-iBtNPSKGxKiysCgQ5_pgihZhUjh1fMc1kM4uurdvSqaMLoP3chr6MvD9J4V2E-ecw_bhzCITkyHMoUmBAIEMSbi6/http%3A%2F%2Fverisigninc.com%2F>

From: Mario Loffredo <[email-masked]><mailto:[email-masked]>
Date: Wednesday, March 30, 2022 at 8:28 AM
To: James Gould <[email-masked]><mailto:[email-masked]>, "[email-masked]"<mailto:[email-masked]> <[email-masked]><mailto:[email-masked]>
Subject: [EXTERNAL] Re: [regext] Comments to the feedback about epp-over-http

Hi James,

my comments are embedded below.

Il 29/03/2022 17:50, Gould, James ha scritto:
Mario,

My responses are embedded below.

--

JG

James Gould
Fellow Engineer
[email-masked]<applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com<http://secure-web.cisco.com/1fmebMbwOUgdo-WyMaIsLZ1SH_XvKhWjFsvhnqk29yAQF2aCDU1bQl0rsVTtHPLG2BkDpIZ4MRjQsieE6r3TIX1L0ZZ7ekjXpaFeAZJDrC_Po6vguQRG0GQxM_3QyDX71rQvTjctNCis34Eb3FlrargkQgR5XO62fk7y3kgDfQM3nIcfYBm16faG667F4c9QVNETKgFbhSeqgY14mUJuMb_4AAv736hwPtIFaeVSRpYMMCGp1ZN1ut0cVsLLpuUa2/http%3A%2F%2Fverisigninc.com%2F>

From: Mario Loffredo <[email-masked]><mailto:[email-masked]>
Date: Tuesday, March 29, 2022 at 11:00 AM
To: James Gould <[email-masked]><mailto:[email-masked]>, "[email-masked]"<mailto:[email-masked]> <[email-masked]><mailto:[email-masked]>
Subject: [EXTERNAL] Re: [regext] Comments to the feedback about epp-over-http

Hi James,
Il 29/03/2022 13:41, Gould, James ha scritto:
Mario,

My feedback is embedded below.

--

JG

James Gould
Fellow Engineer
[email-masked]<applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com<http://secure-web.cisco.com/1EaISbPmlOZzCKgUuIbmDA4rr-y-fT4gnfY0xiPotQBQC-vNT5PBKwJ1STPDcTK6y65BpvZgT5XqntG_ZysxPVZX8XjGyZXOW-P8nL-bdEwKNOkYvtyGhf1-PjTUP3gKykqkaX6QProvtyfCBkgC_m9J8xcE7yHeQ2_JycG85cc1JtO74KeQ6D9bsl9tHxNpgzRFA-IE_CZkI01GCY0-9LRrY2Tdd3mwPuBMAXYl7okYjJdszZFa2vwEdisCoAWAN/http%3A%2F%2Fverisigninc.com%2F>

From: Mario Loffredo <[email-masked]><mailto:[email-masked]>
Date: Monday, March 28, 2022 at 6:59 AM
To: James Gould <[email-masked]><mailto:[email-masked]>, "[email-masked]"<mailto:[email-masked]> <[email-masked]><mailto:[email-masked]>
Subject: [EXTERNAL] Re: [regext] Comments to the feedback about epp-over-http

Hi James,

thanks for ypur quick reply.

Please find my comments below.
Il 25/03/2022 16:45, Gould, James ha scritto:
Mario,

For #4 “Cookie vs. HTTP Connection”, you asked the question “can you further clarify why we should opt for establishing the cookie at setup of the connection and how should it be possible? For example, what kind of request should be used to start the HTTP connection?”.

I implemented pluggable transports in the Verisign EPP SDK, which included HTTP, HTTPS, TCP, and TLS.  The Verisign EPP SDK does include a client interface as well as a server stub implementation, so I was able to see the transports from both sides.  Support for HTTP and HTTPS was removed once we stopped supporting EPP over HTTP.  The cookie is setup at the time of the HTTP or HTTPS connection.  There is no “request” that is used to start the HTTP connection, just like the case for TCP and TLS.  A network connection is made, which includes the underlying TLS handshake in the case of HTTPS and TLS and the cookie is setup for HTTP and HTTPS, and then the EPP application protocol rides on top of it.

It seems to me a very low-level implementation.

Sorry but I stiil don't understand how cookies are returned. They should be returned in an HTTP response that doesn't correspond to an HTTP request. Correct?

JG: HTTP is being defined as a transport for EPP, so it should be treated as such.  The setup and tear-down of the HTTP connection, includes the setup of the cookies that is used for HTTP session tracking.  When a connection is made to the EPP / HTTPS server, the TLS connection is first established via the TLS-handshake and the HTTP session is established via setup of the session cookie (e.g., JSESSIONID), which then enables the server to maintain state.  State such as tracking failed login attempts and timeouts (idle / command / absolute), which will result in a drop in the HTTP session / connection when the login attempt threshold is exceeded.  At the application layer, a HTTPS connection is treated in the same way as a TLS connection, where the transport handles the framing and the connection state, and the application layer returns the EPP Greeting when the connection is setup and drops the connection with a EPP logout occurs or other EPP session conditions (e.g., exceeding timeouts).  The HTTP session cookie is returned in all the HTTP responses.  There is absolutely no intermingling of the transport layer (HTTP) with the application layer (EPP) other than making a connection available to read and write framed packets and the ability to close the connection when needed.

If so, it seems to me uncompliant with what is stated in the first paragraph of Section 2.1 of RFC7230:

   HTTP is a stateless request/response protocol that operates by

   exchanging messages (Section 3<https://secure-web.cisco.com/1HLyHB_XdFEjfXQwGFkG0LZSLLnG4WFNvmZ-TNjfY6OfIaLTmL1biILbx72S_U5GmIiJtbpg0x39TJ52od6XvJJ-XGkebzBiEggAwQ42v85iZAXdc75eWbMUFwdy__GSQvGqoc_3jBcXvzaJksIZ9kIaGCObuN4sNz3NQqB4Gsr44Gdw9c4U6nDx9j_3kyp9hk3Za8zxK-CiPfgUAyNLhZ53ksc5Ae9PHvSSpW9kjbB9txLir0tvwL_pUPzDpJS2Y/https%3A%2F%2Fwww.rfc-editor.org%2Frfc%2Frfc7230%23section-3>) across a reliable transport- or

   session-layer "connection" (Section 6<https://secure-web.cisco.com/1vvJc-KSBR_KweDtRuo-dlLx6E_Z9fnj9TRqKJPKmI-z_MzpIyDJWDzfwvS180O64nU4M_K-HwHtvVlPkTyfnMVQ8I50S_dOCSrwzrW9QXz8ckfa9Yj0UZmgPk4aOBSCgpizCtKhPiufait2c-bik8SwDi5FGriXh2QetIDOP_N5qvkVGUCrJ7Agu0Kz55-5IRTrJpPK2rtdg6AYpfgj-5oaNCOjZ9kZcI233HN_HumLXDVcKmYklOTTqh_7mGPwt/https%3A%2F%2Fwww.rfc-editor.org%2Frfc%2Frfc7230%23section-6>).  An HTTP "client" is a

   program that establishes a connection to a server for the purpose of

   sending one or more HTTP requests.  An HTTP "server" is a program

   that accepts connections in order to service HTTP requests by sending

   HTTP responses.

JG: I don’t see how using HTTP as a EPP transport would be considered uncompliant with RFC7230.  Below is the flow of using HTTP as an EPP transport:
1.       Establish TCP connection
2.       Establish TLS session via TLS-handshake
3.       Establish HTTP session via setup of the HTTP session cookie (e.g., JSESSIONID)
4.       Return EPP Greeting in framed HTTP response with the session cookie (e.g., JSESSIONID)
5.       Support HTTP requests in the form of framed EPP commands that are returned in HTTP responses in the form of framed EPP responses.
6.       EPP session ends that drops the connection (HTTP / TLS / TCP)

[ML] I apologize James but I still don't understand how it would be possible to return an HTTP response including the EPP Greeting and establish a session cookie without having previously received an HTTP request or, to say it better, how it would be possible at the abstraction level provided by all the libraries and frameworks supporting HTTP communication on both client and server side.

Being HTTP used as a purely transport (L4) protocol but not as a request/response (L7) protocol,  the implementation wouldn't be compliant with RFC7230.

The same concept is also repeated in Section 2.1 of RFC 2818 "HTTP over TLS":

   The agent acting as the HTTP client should also act as the TLS

   client.  It should initiate a connection to the server on the

   appropriate port and then send the TLS ClientHello to begin the TLS

   handshake. When the TLS handshake has finished. The client may then

   initiate the first HTTP request.  All HTTP data MUST be sent as TLS

   "application data".  Normal HTTP behavior, including retained

   connections should be followed.

JG: The first step is a HTTP GET request that establishes the HTTP session and receives the EPP Greeting in the HTTP GET response, which includes the HTTP session cookie.  Subsequent requests can use a HTTP POST for the EPP command and receive the HTTPS POST response for the EPP response.  The EPP SDK Stub Server supported use of either the HTTP GET or POST and if a HTTP session did not exist, it returned the EPP Greeting in the HTTP response with the HTTP session cookie.  After the HTTP session was established, the responsibility of the HTTP layer was strictly to accept HTTP requests, which works as the packet framing of TCP, and places the EPP responses in the HTTP responses.  The HTTP request and response is fully compliance with the RFCs, since the connection is a request with a greeting response, and subsequent EPP command and responses are handled in HTTP requests and responses.  Connection state is maintained in the HTTP session, which would deal with issues like a failed login threshold and timeouts (idle and command).  The Verisign EPP SDK includes an packet assembler class, which is configurable, which deals with the marshaling and unmarshaling of the commands and responses of the underlying EPP transport, which included assemblers for TCP, TLS, HTTP, and HTTPS.  You could even setup client session pools using the assembler of your choice, where a single client could interface with an EPP/TLS server and an EPP/HTTPS server, all by specifying the desired EPP transport.  If you are to mix the EPP protocol with the underlying transport layer, then it would remove the ability to plug in the desired transport.

[ML] Now everything is clear to me. I didn't udenstrand your previous message because you omitted that a client starts the HTTP session via HTTP GET :-)

Both .it and .pl  implement only the POST method. HTTP and EPP sessions are started together and linked each other after a Login command due to the following reasons:
1.       The session ID is the unique key to retrieve EPP session information

JG: That intermingles the application layer with the transport.  Do you support EPP / TLS in parallel with EPP / HTTPS?  If so, this intermingling would pose an issue.  The EPP session id should be independent of the HTTPS session id.
[ML] If I'm sure to generate every time a unique session ID, it doesn't matter if I support EPP/TLS together with EPP/HTTPS or not. It will be unique anyway. Don't understand why I should generate two unique session IDs, one to be used as session cookie and one to be used as EPP session identifier and then link them together ?!

2) Except for the client IP address, the information that a server must maintain as long as an EPP session lives is included in the Login request (i.e. the registrar name and the XML namespaces)

3) It's very unlikely that an EPP client doesn't know the services provided by a given EPP server

JG: Does this mean that .it and .pl doesn’t provide the EPP Greeting when the connection is established?  Returning the EPP Greeting at the time of connection is a requirement in RFC 5730 “An EPP server MUST respond to client-initiated communication (which can be either a lower-layer connection request or an EPP service discovery message) by returning a greeting to a client.”.
[ML] Since RFC5730 states that Greeting can be returned in response to an Hello either, we are compliant.

JG – I don’t agree that not returning the EPP Greeting upon the initial connection is compliant with RFC 5730  “An EPP server MUST respond to client-initiated communication (which can be either a lower-layer connection request or an EPP service discovery message) by returning a greeting to a client.”.  By not supporting the EPP Greeting upon the initial connection, I believe it’s a violation of RFC 5730 and needs to be supported in a supported transport for EPP.

4) As a consequence of point 2 and 3, why should a client submit a meaningless HTTP request to the server before submitting the Login command  to start an EPP session?

JG: The EPP transport needs to support what is defined in RFC 5730.  The connection is established and the server returns an EPP Greeting.

[ML] The HTTP connection might be established at any HTTP request the EPP client sends to the EPP server. If the interval between two subsequent HTTP requests exceeds the Keep-Alive timeout set b the HTTP server, the HTTP connection is established again. The session cookie is the mechanism that allows an HTTP-based EPP server to trace all the HTTP requests back to an EPP session.

An HTTP-based EPP server is able to manage requests, responses and sessions. It cannot manage connections because they are managed automatically at a lower layer.

JG – The HTTP session id is setup upon the first request (GET or POST) when it does not exist.  The code in the Verisign EPP SDK looks for the session cookie and if it doesn’t already exists set it.  This means that once the connection is established, the HTTP session is setup and the EPP Greeting is returned.  I don’t see the point in not setting up the HTTP session id upon the initial connection.

5) RFC5730 states that an EPP session starts with a <Login> command and RFC6265 states that servers maintain stateful sessions over HTTP by setting the session cookie. Hence, It seems natural to me that servers start an HTTP session  and set the session ID after a successful Login command.

JG: The EPP session may start with the login command, but the transport session is established ahead of the EPP session being established.

[ML] In HTTP, a physical transport session doesn't exist. The stateful session is simulated via the session cookie over single HTTP connections. If the Keep-Alive is on, a TCP connection can be reused to issue multiple HTTP requests.

JG – HTTP is being defined as the transport for EPP in the draft, so the first step is to ensure that the HTTP session is setup so that the EPP application protocol can ride on top of it.

But this is not guaranteed.

6) Application protocol sessions on server side normally start after authenticating the client (please note that this is exactly what we are pursuing in RDAP)

JG: You really need to follow the flow defined in RFC 5730 for an EPP transport.  My recommendation again is to set the HTTP session id at the time of the connection and have the server return the EPP Greeting, just like what occurs with EPP over TLS.  The transport should not intermingle with the application protocol, which enables the pluggable of transports on the client-side and the server-side.

7) It seems inefficient to release an HTTP session from an EPP session because it can result in wasting resources to maintain possible useless HTTP sessions.

JG: I don’t see the wasting resource use case here.  When a client makes an EPP over HTTPS connection to the server, the HTTP session is established and EPP rides on top of it.  The first EPP packet sent is the EPP Greeting by the server.  The server can establish policies such as maximum failed login attempts to drop the connection.

[ML] So could a client send tons of HTTP GET without being blocked?

JG – The network layer can limit the number of concurrent connections when using either HTTP or TCP as the EPP transport.

8) If an HTTP session is not established after an authentication, IP whitelisting is a must instead of a recommendation. Even if in general registries require registrars to declare their own clients' IP addresses out-of-band, this is not an absolute constraint and the same IP address might be used by multiple registrars. For the same reason, you cannot limit the number of HTTP sessions per registrar thus mitigating the risks pointed out in point 7.

JG: IP whilelisting can be aggregated in the ACL and then checked during the login command.
[ML] See my previous comment.

Regarding to the EPP commands, other than Hello and Login, that don't include a valid session ID,  think it's better the server returns an EPP error ("Command use error") instead of a Greeting response including a new session ID.

JG: If you’re not returning the EPP Greeting at the time of the connection, you’re not implementing EPP.  The definition of an EPP transport needs to fully support the EPP protocol defined in RFC 5730.

[ML] This is exactly what happens also in your implementation. An HTTP connection can be established by issuing an HTTP GET but it might happen that a new one is established by issuing the subsequent POST for the Login command.

In the first case, your server returns a Greeting response while in the second your server retuns the Login response. In both cases, a new HTTP connection is created.

Even if you set the EPP session timeout equals to the Keep-Alive timeout, you can be sure that two subsequent requests are using the same HTTP connection.

You can realize that if you control the HTTP connections but these means that you are working at a programming level that doesn't correspond to that provided by libraries and frameworks supporting HTTP on both client and server side.

My personal opinion is that such an interpretation of EPP over HTTP is actually impractical.

Have a question: how do you figure out the case where a client issues two Login commands with the same valid session ID previously received via the GET response? I imagine that only one would be accepted.

If so, the mapping between an HTTP session and EPP session exists also in your implementation. It occurs when the EPP session is created instead of when the HTTP session is created.

JG: The HTTP session maps to the state held on the server-side, which would include items like the client IP address, client certificate, and other attributes that can be used along with the passed user name and password in the login command.  The EPP HTTP transport should handle the same features as EPP TCP in RFC 5734, which includes the connection requirements (e.g., TLS) and the method of packet framing.  In the case of HTTP, there is the need for establishing the HTTP Session Id and using the HTTP request and response packets for containing / framing the EPP packets.

[ML] Why should a client certificate be stored in the EPP session?

JG – The client certificate can be gathered at the time of the connection, based on the TLS handshake.  It can be used along with the client IP address as a second factor in the login command.  The connection is established, the HTTP session is established, and the client IP address and the client certificate is stored in the HTTP session for a subsequent call to the login command, which includes the login name and password.  By establishing the HTTP session at the time of the session and storing the client IP address and the client certificate in the HTTP session, the subsequent HTTP request containing the EPP login command is routed to the same server with the HTTP session to support multifactor authentication.

Best

Mario

Best,

Mario

7.

Anyway, the approach normally followed by every HTTP implementer leverages the services provided by an application server that incorporates an HTTP server.

You don't need to manage HTTP connections, HTTP resquest/response marhsalling/unmarshalling and other low-level details. You just need to focus on the core of your server.

Similarly, on the other side side, after having configured an HTTP client instance, a client simply builds and sends an HTTP request, and  then receives and processes an HTTP response.

JG: An EPP client or server should be capable of reusing all the same command and response processing without dealing with transport specific logic.  The transport layer can be built as a layer that is pluggable.  A client can configure the transport to use on a per-server basis, and the server can reuse the same command processing logic whether running on top of TLS or HTTPS, since TLS and HTTPS are purely transports.

[ML] It's unclear to me how two communications working at different layers could be handled in the same way. As I wrote in my previous reply to Matthias, the approach proposed aims to preserve EPP commands semantics so that the EPP server core should be the same regardless the fact that it is supported by HTTP or TCP.

JG: It's very straight forward to make the EPP transport pluggable if you treat the EPP transport as purely a transport.  The application layer does need to go through a pluggable transport layer to enable the transport layer to frame, and marshal/unmarshal the commands and responses.  In the case of the Verisign EPP SDK, that assembler layer took care of it for TCP, TLS, HTTP, and HTTPS.  The EPP command processing is not dependent on the transport layer, meaning the EPP command processing layer doesn’t need to be concerned with setting a HTTP session cookie upon a successful EPP Login or handling the EPP Hello in any special way as it relates to HTTP cookies.  EPP is a stateful protocol, where the underlying transport needs to support being stateful.  If the desire was to move towards stateless, then you’re not defining an EPP transport but a new EPP protocol.  My recommendation is to keep the EPP over HTTP simple and establish the HTTP cookie at the setup of the HTTP connection and separate the EPP sessions from the HTTP session.

Mario
If there is a HTTP transport for EPP, then it should be purely a transport and not intermingle with the application protocol.  There is no need to directly tie a HTTP session with the established EPP session.  By keeping them separate, it makes it much easier for the client and the server to have pluggable transports, where the processing of the EPP commands including the hello, login, and logout treat the transport as simply a connection with no intermingling of session management.

If it means that you have to reimplement what has commonly been used for years, it isn't clear to me how it could be much easier. On the contrary, it seems to me much trickier, especially if you implement EPP-over-HTTP from scratch.

If the goal is using the same approach for mapping every transport layer without considering the peculiarites of each transport protocol and the technology the implementers are accostumed to use to deal with them, it doesn't make sense to me.

For example, I cannot figure out how HTTP load balancing could support your solution.

JG: The HTTP transport for EPP can easily be defined as a pure transport, which provides a connection for the application layer to leverage in the same fashion as TLS.  The load balancer can leverage the TLS session id to route to the EPP gateway and in the case of HTTP, the HTTP session can be used to route the request to the appropriate application server that contains the connection state.  Some HTTP application server proxies leverage the HTTP session to route the requests to the application server that contains the HTTP session and state.  You need to establish the HTTP session when the connection is established to support the needed routing.  There are other load balancing options, but by simplifying EPP over HTTP to have HTTP as purely a transport, it provides maximum flexibility in routing and maximum pluggability of transports (TCP, TLS, HTTP, HTTPS).

Best,

Mario

--

JG

James Gould
Fellow Engineer
[email-masked]<applewebdata://13890C55-AAE8-4BF3-A6CE-B4BA42740803/[email-masked]>

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com<http://secure-web.cisco.com/1ojxKstUEceETR7pe4khQ2dcwgGUwoOuZu4vhcT-TZcTCCpM93jXl6eq5i46tfTPt6lE9M6FO7hPqFZQVgxN5su1ozpEIXrOmp6SzB5kEB5SXCcRaJIg-vRb2B_SxGeDcgjxTqmZNEVO_Z0LtwZEFTLbzsLhmMMT-MlZ9pX7rpBY6Q8K0RxXyklhUEXCOqlJ0RMcZX2tEZNHp0Pr6XFhgw4X7OA0XCs0tk_jqiJbYMrkAFF0PXiAItfCmm_MR8whC/http%3A%2F%2Fverisigninc.com%2F>

From: regext <[email-masked]><mailto:[email-masked]> on behalf of Mario Loffredo <[email-masked]><mailto:[email-masked]>
Date: Friday, March 25, 2022 at 11:01 AM
To: "[email-masked]"<mailto:[email-masked]> <[email-masked]><mailto:[email-masked]>
Subject: [EXTERNAL] [regext] Comments to the feedback about epp-over-http

Hi folks,

here are in the following some comments grouped by subject to last meeting's feedback about EPP-over-HTTP:

1) Draft title

Ulrich suggested to call the document EPP-over-HTTPS.

I replied that the name was assigned to be consistent with RFC5734, i.e. EPP-over-TCP.

SImilarly to RFC5734, the draft states, first in the abstract and then in the security considerations, that TLS is required.

That being said, the authors don't object to renaming the dcocument EPP-over-HTTPS if the WG agrees.

2)  Cookies

Jim (Reed) asked why cookies should be used in this case.

The reasons why we have used session cookiea are that they represent a standard method (RFC6265), well known to the community of REST service implementers, largely used and natively supported by libraries and frameworks on both client and server side. For example, it is the same method used by rdap-openid to map an RDAP session and tie it to an access token :-)

.it and .pl have been using this method since the beginning and the registrars, after being informed that they had to enable cookies in their HTTP clients, have no longer complained about cookie management.
In addition, the implementation of such a method doesn't  introduce any change to the EPP core spec. Indeed, it preserves EPP comands semantics and doesn't mix the application layer with the transport layer.

I would like to say that, regarding the clear distinction between those layers, this proposal is even better than RFC5734 as every EPP response is returned by the server as a consequence of receiving an EPP request.

On the contrary, in RFC5734, an EPP <greeting> is returned to the client after the TCP connection has been established so, at least in this case, the two layers get mixed.

3)   Security Considerations

Ulirch recommended to review the security considerations by inheriting those from TLS WG about which versions and ciphers of TLS to use.

Thanks a lot for the heads up, Ulrich. Surely, we'll do.

Gavin noted that, unlike EPP-over-TCP, this draft states that client IP address check is optional.

As a matter of fact, it is stated as recommended.

Anyway, the authors don't object to changing it into an absolute rquirement if the WG agrees.

4)  Cookie vs. HTTP Connection

One comment from James in the chat is about establishing the cookie at setup of the connection and not linking it to the EPP Login command.
James, can you further clarify why we should opt for establishing the cookie at setup of the connection and how shoudl it be possible? For example, what kind of request should be used to start the HTTP connection?

IMO, an HTTP session is something that is inherently unlinked to the HTTP connections.

HTTP connections can be broken but sessions don't get lost.

Programmatically, REST implementers are in charge of processing HTTP requests and building responses rather than managing HTTP connections, which is instead delegated to the application servers.

Finally, I would like to outline that Section 2.9.1 of RFC5730 states that an EPP session starts with a Login command and the mechanism described by RFC6265 lets (I'm quoting here) "the servers maintain a stateful session over the mostly stateless HTTP protocol". As a consequence, it seems much more practical to start the EPP/HTTP session as a result of a Login command.

5) EPP/HTTP Sessions vs. HTTP3 Connections

Ulrich remarked that, in HTTP3, it is possible to have multiple sessions on an HTTP connection.

This is valid also for the other HTTP versions.

In fact, an HTTP connection can be kept alive and, over it, a client could submit multiple login-commands-logout sequences.

This is quite usual for a smart client managing a pool of HTTP connections.

Instead, It is unlikely but not impossible to come across HTTP connections supporting multiple concurrent sessions.

What should be the possible drawbacks for a server in allowing the scenarios above?

6) Client authentication in HTTP3

Another note pointed out that HTTP3 client authentication requirements are different from this draft and they need to be reconciled.

Think that it could be sufficient to add to the security considerations some text similar to what is included in section 4.4 "Peer authentication" of RFC 9001 "Using TLS to secure QUIC":

   A client MUST authenticate the identity of the server.  This

   typically involves verification that the identity of the server is

   included in a certificate and that the certificate is issued by a

   trusted entity (see for example [RFC2818<https://secure-web.cisco.com/1tkPqD6aAMfTp6t6KppHDGdn0xpgOWSMeCqwZR-hs9Duph9SiceA0vCbaJJVqywNzcZscc6vUZkCPH9lCdtXq_nVJ3OfnNMz-XTQvhBuSBLsXa0VfO5ZNrGo47fSin8GRaQOWRSvSQP_7vRecBdddhF6L0Yqx3KcxAGpvdxpFCsPhLcd5bm-aVy3vTko6TfGBlohe2XEw3bwUmH-u56ZuZz50CUXUqA3YDFgBENAwPrLBjwdDxwgG1JFVGPZF_LEQ/https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fhtml%2Frfc2818>]).

The draft has only considered the optional use of a certificate on server side (not on client side). In doing that, the draft is consistent with another sentence in the same paragraph of RFC9001:

   A server MAY request that the client authenticate during the

   handshake.  A server MAY refuse a connection if the client is unable

   to authenticate when requested.

Would it address the feedback?

That's all for now.

Hope I did not miss anything.

Thanks a lot for your interest and feedback.

Looking forward to your further comments.

Best,

Mario

--

Dr. Mario Loffredo

Phone: +39.0503153497

Web: http://www.iit.cnr.it/mario.loffredo<http://secure-web.cisco.com/1Af0lIvD4wj2TkngfEVwrFVEVRozLiVIU2m1Gi1AH1GN4-eWP-IREXsOLCh8OJ03YAxRNYqVCPHQSwgj-tMCyzvN3jokOBTIBx4-5n1pJdiRXxl-ShJCaHkCjGNPa8EA5qw4kPjkxIrFAy1qOTcPFhieqdc_xyu8yisYoXzily9ozVw3GZaUtkKrLnmnDJhlFv2LRTCTnw913LzH8bX-hB6FpPlyFi_0v2_H1NFCgZYjuu4pgUeOeIqQJRQwtzNLS/http%3A%2F%2Fwww.iit.cnr.it%2Fmario.loffredo>

--

Dr. Mario Loffredo

Phone: +39.0503153497

Web: http://www.iit.cnr.it/mario.loffredo<http://secure-web.cisco.com/1OpUT5efcRPCKu9ZmpfyFmbeoIexTqMIlduFKl7VTUSeET1W3oogufCAfJPPw-WSQ0iyo_wkztY_7M69qw0yf13C4w7OWB_Zk5w2FsV-GGCSLot8lFQdslU0DvCpCTw9FjZr0AsFsubGH-kToYrLxzzEj7vGDKuxIFxPK92P5bu2CDOE4UFtRPRGvu9rzX83rks8X2le_j1uSS1SD5B8CyvSp0tsne0HWMS5luho_DIhdOil7-0a_7ZX6CQA08GQq/http%3A%2F%2Fwww.iit.cnr.it%2Fmario.loffredo>

regext mailing list

[email-masked]<mailto:[email-masked]>

https://www.ietf.org/mailman/listinfo/regext<https://secure-web.cisco.com/16jl36WEWq0s-czRNUY5mezogTB1s8eM6-POsf3osvBxTtShse2Gx3vayC92AUxQ8ebDwE9Ob8SzhMcrkTCHnZy_RbpQlkSPKyyG9v1LOvWmmr2bX-q2Kwz-52tKvzlBlfgMU_rKnCsIFS9e53n9Fl1sqideuhzE2Qvq05_MQ6tGzuKP1z0P4vYyDR8QmVl4xwlz-BKFhZLijpQYz9CLe61qg3JAC0a2ldUiZMLUwjnSSssMNXvvVibSRdv-9l9yg/https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fregext>

--

Dr. Mario Loffredo

Phone: +39.0503153497

Web: http://www.iit.cnr.it/mario.loffredo<http://secure-web.cisco.com/1yKvefSSzzB1xtPf0Zt9UvXnOkA28n5LvF1HkMnNZqV6Dwz7x7ZD06GbmS94ZAQwsmSA6iszQPAkGi5fNCSMjCHwEbful0vNQc0bfu7a2ydpIkKyqCYgjHlBp7I_-3eCZXAtMTjU_xfTEae9EnXNbksctYNkGyOsHDR02jSoOeVLa3lgW8hWUZ20zgxxFQlt_HdsERDtOQY4EoiE3orLFHDV3wtSA-ChHIYVp1pfMvU2aCEBQ3tWEhFOLp740jUPP/http%3A%2F%2Fwww.iit.cnr.it%2Fmario.loffredo>

--

Dr. Mario Loffredo

Phone: +39.0503153497

Web: http://www.iit.cnr.it/mario.loffredo<http://secure-web.cisco.com/1pp2UVbYq0m0PdgNAIf-MFBBPlI6rgwJb-nl0OyxKTaZvJklLUlXEVPn3qvn6ziLbUr86nSYHSn9PLRlT1wKKUgtGjJOdnJ8Ghkk3hlYjxMa4J4AaIOBZ7WvzWPIEvoHPBVb2TdHFIKvtiJkT5ev0nRTy-ErBgM9XRxiNe_p-wkwdeLKKqJWcyzpKSrlr3WZKQaTzmyHAwtIPMymiYesdU2YUhfSeGkOO4qysnLCFQpp6nqMFwr28xmvjE8p7Rz8v/http%3A%2F%2Fwww.iit.cnr.it%2Fmario.loffredo>

regext mailing list

[email-masked]<mailto:[email-masked]>

https://www.ietf.org/mailman/listinfo/regext<https://secure-web.cisco.com/1_yXrltn2RrdNqPaGnsV60e0pSnpG8AzTQaKHAHbw6tQQMN0n3KvNvk-k2czAi4aJNkNyi_TCbSql8OP19bk6mxSZ-wdw-2iLikdj4eoHyXrRLQ6AZ4Rbq4_BoJMLgvEo8RgkfTbr8vCOfDJUkZxDCg2k9Cw5hk6lyE4n7a08e61-x_2-sGZoXxxxBfsAiipo8fC6lwPln1Ub3I7GQm-M6cQvbO-I_pvCAJhp_XEp81GqKdUvURiK0DaIyddU_RiV/https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fregext>

--

Dr. Mario Loffredo

Phone: +39.0503153497

Web: http://www.iit.cnr.it/mario.loffredo<http://secure-web.cisco.com/1BqyjYkdvXBcwVWa84XA906u3mzf_pX_IUrm7hEpf7HgIUzbx68LDl16TpMYtODran7zcDllDjXB4l-pQCP2UQabWdEqNLwIBtWcLGAcPJyvs_ASYN6lh6lt2vwLLqHjWmOJeM7SntP0o5MxDocAQay1pbOuci45uk31fRguNetPyWM1TcYm1F8JJ8WQoA3486mym_YuBRrKGq_m2SiIX4kO7z8xfUu1akXeIOLhebOLsyZOr6PXPof4QVQFyh7Gb/http%3A%2F%2Fwww.iit.cnr.it%2Fmario.loffredo>

---

From: "Gould, James" <[email-masked]>
Date: Thu, 31 Mar 2022 12:42:38 +0000

Mario,

I’m getting confused on the purpose of the epp-over-http draft.  If the goal is to define HTTP as a transport for EPP, then it needs to fully comply with RFC 5730.  EPP is a stateful protocol and the transport underneath it needs to support a stateful session.  HTTP does have the concept of a session id, which can be leveraged to maintain state with an HTTP session that uses keep-alive or not.  The EPP application protocol should not need to be aware of the particulars of the underlying transport, where the connection session and the packet framing is handled.  The implementation needs to consider the hierarchy of timeouts, where you point out the HTTP idle timeout cannot be lower than the EPP idle timeout.  The setup and teardown of the transport session can be modeled in HTTP in a similar fashion as is done with TCP.  The application protocol deals at the level of packets that are passed across the underlying transport.  The EPP packets can certainly support a HTTP transport as defined in RFC 5730 with the use of a HTTP GET to start the EPP connection, which returns the EPP Greeting with the HTTP Session Cookie (e.g., JSESSIONID), the EPP commands can ride in HTTP POST requests, and the EPP responses can ride in HTTP POST responses.  The start of the transport session is handled via creating the HTTP session cookie and terminated by invalidating it.  This is different from how it’s handled for TLS, but from the EPP application-level it can and should be abstracted.

You state “With regard to the compliance with RFC5730, the proposed approach interprets the specification on the basis that HTTP is neither connectionless nor connection-oriented”.  The key aspect is whether HTTP can be stateful to support the stateful EPP protocol, which it can by leveraging the start and ending of the HTTP session.  There is no dependency on whether it’s connectionless or connection-oriented if the transport can have a defined beginning and end with the ability to frame the EPP packets.  The flow of EPP must be followed, where the client communication is initiated with the server returning an EPP Greeting (e.g., response to HTTP GET), following by a flow of EPP commands and responses (HTTP POST requests and responses).  If the epp-over-http approach does not support this flow, then it’s not complaint with RFC5730 and is not a valid EPP transport option.  I’ve communicated an approach with defining HTTP as a fully compliant EPP transport.

Thanks,

--

JG

James Gould
Fellow Engineer

703-948-3271
12061 Bluemont Way
Reston, VA 20190

From: Mario Loffredo <[email-masked]>
Date: Thursday, March 31, 2022 at 7:54 AM
To: James Gould <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: [EXTERNAL] Re: [regext] Comments to the feedback about epp-over-http

Hi James,

For what I have understood, your implementation is based on the assumption that once the HTTP Connection is established, it is used for the transit of all the HTTP requests of an EPP session, starting from the Login and ending with the Logout.

Consequently, you rely on keeping the HTTP connection alive as long as the EPP session works. Correct?

If so, in my opinion, that is a wrong assumption.

Clients should not be forced to keep alive the HTTP connections if HTTP allows to maintain HTTP sessions alive across a sequence of HTTP  connections.

There are other implications connected with the Keep-Alive Timeout value.

Don't know how did you set the Keep-Alive Timeout: the default value is 60 secs.

As a consequence, the EPP session timeout value in your implementation cannot be higher than the Keep-Alive timeout value, othewise you might have the case that an EPP session is still alive but the underlying HTTP conection isn't.

Another consequence of binding EPP session to HTTP connections is that, when a server is stopped, not only the ongoing EPP requests get lost, but also all the corresponding EPP sessions.

Finally, another factor to consider is that there could be some intermediaries (proxies) in the middle. Each of them can set their own Keep-Alive Timeout you can't control.

On the other hand, following the commonly used approach to make the EPP session completely independent on the HTTP conections would contribute to make an HTTP-based EPP server more manageable, efficient, flexible and fault tollerant.

In my previous mail, I wrote that your implementation seems to me impractical because currently no HTTP programmer on both client and server side is accostumed to deal directly with HTTP connections because that job is done by  the application server (or similar) on top of which you deploy (or built) your application based on a high-level protocol such as EPP and RDAP. Following this apporach, the implementation of EPP-over-HTTP would not be affected by the possible change of the HTTP version supported.

Surely, one can tune the performance of the entire server by setting some parameters regarding HTTP connections but basically the main job consists in processing the requests to return the responses, That's it. On client side, you can configure a connection pool instead of starting-ending an HTTP connection every time an HTTP request is sent but even client libraries allows for creating an HTTP client instance and using it to send HTTP requests and process the related responses.
We cannot use HTTP as it was TCP. There are three layers in the middle that save HTTP programmers from being involved in low-level details (luckily).

With regard to the compliance with RFC5730, the proposed approach interprets the specification on the basis that HTTP is neither connectionless nor connection-oriented.

It still runs on top of a connection-oriented transport (typically TCP), but it does not assign any state to that particular connection. The client is free to re-use the same connection for multiple requests (as many HTTP/1.1 clients do), or to create a brand new connection for each request (as HTTP/1.0 clients used to do).

Best,

Mario

--

JG

James Gould
Fellow Engineer

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Verisign.com<http://secure-web.cisco.com/15Qy7W1U4C31ZtwIvgWqzOtoL9T3NQ8zD0WI6bJDE9AN-K3LSYAkDkMcjdfwYRD1SCVF6SjE0CSLX4Lc7AWqJpioXQy2X1UkDvVETEPI5top1RJX9xQSIPqa0Dd_UK5ASep8KZ7aLr6MKnmgVaeAMHLGA5yaHCzpH4lvAPcY6pwApb1rJGAJK38DoTNmLiWnd3ymgNSraSVXBQRXVakYkLWfzYYujSWdTUHb8Sa2Wf-QXmUZw5PuK2PD4ozr0eQ8r/http%3A%2F%2Fverisigninc.com%2F>

Hi James,

--

JG

James Gould
Fellow Engineer

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Hi James,

--

JG

James Gould
Fellow Engineer

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Hi James,

   HTTP responses.

Best,

Mario

7.

Mario

Best,

Mario

--

JG

James Gould
Fellow Engineer

703-948-3271
12061 Bluemont Way
Reston, VA 20190

Hi folks,

1) Draft title

2)  Cookies

That's all for now.

Best,

Mario

--

Dr. Mario Loffredo

Phone: +39.0503153497

--

Dr. Mario Loffredo

Phone: +39.0503153497

regext mailing list

--

Dr. Mario Loffredo

Phone: +39.0503153497

--

Dr. Mario Loffredo

Phone: +39.0503153497

regext mailing list

https://www.ietf.org/mailman/listinfo/regext<https://secure-web.cisco.com/1ke_xPqxdwIlJke6tDE-BObkYg5_xLaQTio9Jmj-TRg-g3n923818OFYkighspnxRPKpqb5EBGkObne0ar2lHDHWTQx3p2fkhtDNyYaKXG38_YVMaEwmV5VA-wDU-IQOIVAaV7nvrjqPaGNwz0kiR0A1vITQzdyXZC5TF5JXpauKs0m6XY-T4lJLRdOdvVRO27qQNzglYgg1lpI72a34tpntsN_BTsfhJJ08ExJn_zITwCdiOkH0F4eT1SGasrOrE/https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fregext>

--

Dr. Mario Loffredo

Phone: +39.0503153497

Web: http://www.iit.cnr.it/mario.loffredo<http://secure-web.cisco.com/1YZUWdVJoxsTDwxw8BM5EGaLgHZq3TYfzQtbIV1mqW3py98gjrVRerVd3L8g3hssS159lLfgJnvoqbWC8rsw86GslN-KkYYHfcry3e-kBF7cAbqn1MHKeT257xWY0wO6VdssOpRqxCLf5vtovMesk5SSEXCJedEtJSprJZx-bb3rTRhVdE6McgI_zAbniSn21kNvxnN1VQfiSiMB22isCYMYC2A2Jtm0wf1w1r1j7DkHky1xx8BfgV6zgfa4OQW1_/http%3A%2F%2Fwww.iit.cnr.it%2Fmario.loffredo>